//
//  BannerTemplateViewController.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/18/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit
import RxSwift
import RxCocoa

final class BannerTemplateViewController: UIViewController, BannerTemplateViewInterface {
    
    // MARK: - Public properties -
    
//    @IBOutlet weak var categoriesSectionWrapView: UIView!
    
    @IBOutlet private weak var categoriesItemStackView: UIStackView!
    
    let categoriesItem = BehaviorRelay<[CategoryItem]>(value: [])
    private let viewDidLoadRelay = BehaviorRelay(value: false)
    
    private let disposeBag = DisposeBag()
    
    var presenter: BannerTemplatePresenterInterface!
    
    // MARK: - Lifecycle -
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        defer {
            viewDidLoadRelay.accept(true)
        }
        
        configurePresenter()
    }
    
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        configureViews()
    }
    
}

// MARK: - Extensions -

extension BannerTemplateViewController {
    
    private func configurePresenter() {
        let didLoad = viewDidLoadRelay.asObservable()
        categoriesItem.filterEmpty().takeLatestWhen(didLoad)
            .asDriver(onErrorDriveWith: .never())
            .driveNext { [weak self] categoriesItem in
                self?.addCategoriesItem(categoriesItem)
            }
            .disposed(by: disposeBag)
    }
    
    private func addCategoriesItem(_ items: [CategoryItem]) {
        categoriesItemStackView.arrangedSubviews.forEach { $0.removeFromSuperview() }
        items.forEach { item in
            let categoryItemView = CategoryItemView()
                .setIconContainerBackgroundColor(item.containerBackgroundColor)
                .setCategoryTitle(item.title)
            categoriesItemStackView.addArrangedSubview(categoryItemView)
        }
    }
    
    private func configureViews() {
//        view.addTopRoundedCornerToView(targetView: categoriesSectionWrapView, desiredCurve: 0.6)
    }
}

@IBDesignable class SuperSpaManagementTopCurvedView: UIView {
    
    @IBInspectable var curvedBackgroundColor: UIColor = UIColor.white {
        didSet {
            self.setNeedsDisplay()
        }
    }
    
    @IBInspectable var topPadding: CGFloat = 32.0 {
        didSet {
            setNeedsDisplay()
        }
    }
    
    override func layoutSubviews() {
        self.backgroundColor = .clear
     }

    override func draw(_ rect: CGRect) {
        let y:CGFloat = topPadding
        let myBezier = UIBezierPath()
        myBezier.move(to: CGPoint(x: 0, y: y))
        myBezier.addQuadCurve(to: CGPoint(x: rect.width, y: y), controlPoint: CGPoint(x: rect.width / 2, y: .zero))
        myBezier.addLine(to: CGPoint(x: rect.width, y: rect.height))
        myBezier.addLine(to: CGPoint(x: 0, y: rect.height))
        myBezier.close()
        curvedBackgroundColor.setFill()
        myBezier.fill()
    }
}
